#include <ntddk.h>

//static __int64 oldMsrValue = 0;
static void *oldKiFastCallEntry = NULL;

static void __stdcall SystemCall()
{
  static LONG count = 0;
  //static const LONG throttle = 10000;

  LONG n = InterlockedIncrement(&count);
  
  UnhookSysenter();
  
  __asm
  {
	mox eax, 0x52
	lea edx, [esp+4]
	int 0x2E
	ret 0x2C
  }
  
  HookSysenter();

  //if (n % throttle == 0)
  //  DbgPrint("Another %ld of `sysenter`s (eax=)!\n", throttle);
}

static void  __declspec(naked) NewKiFastCallEntry()
{
  __asm
  {
    pushad 
    pushfd 
    mov ecx, 0x23
    push 0x30 
    pop fs 
    mov ds, cx 
    mov es, cx
    call SystemCall
    popfd
    popad 
    jmp [oldKiFastCallEntry]
  }
}

#define IA32_SYSENTER_EIP 0x176

static void HookSysenter()
{
  __asm
  {
    mov ecx, IA32_SYSENTER_EIP 
    rdmsr 
    mov oldKiFastCallEntry, eax
    mov eax, NewKiFastCallEntry
    xor edx, edx 
    wrmsr 
  }

  /* oldMsrValue = __readmsr(IA32_SYSENTER_EIP);
  oldKiFastCallEntry = (void *) oldMsrValue;
  __writemsr(IA32_SYSENTER_EIP, NewKiFastCallEntry); */
}

static void UnhookSysenter()
{
  __asm
  {
    mov ecx, IA32_SYSENTER_EIP
    mov eax, oldKiFastCallEntry
    xor edx, edx
    wrmsr
  }

  //__writemsr(IA32_SYSENTER_EIP, oldMsrValue);
}

static void DriverUnload(DRIVER_OBJECT *driverObject)
{
  KTIMER timer;
  LARGE_INTEGER timeOut;

  UnhookSysenter();

  KeInitializeTimer(&timer);
  timeOut.QuadPart = -30000000; // 3 sec
  KeSetTimer(&timer, timeOut, NULL);

  KeWaitForSingleObject(&timer, Executive, KernelMode, FALSE, NULL);
}

NTSTATUS DriverEntry(DRIVER_OBJECT *driverObject, UNICODE_STRING *registryPath)
{
  driverObject->DriverUnload = DriverUnload;
  HookSysenter();
  return STATUS_SUCCESS;
}
